#include	<stdio.h>
#include	<stdlib.h>
#include	<conio.h>
#include	<ctype.h>
#include	<io.h>
#include	<fcntl.h>
#include	<sys\types.h>
#include	<sys\stat.h>

typedef unsigned char	uchar;
typedef unsigned int		uint;

uchar	C14[32], D14[32], E14[32], F14[256], E8[32], J14[32];

// Setup a table of line names

void readProms( void)
{
	int	inFile, err;

	inFile = _open( "prom.e8", O_BINARY | O_RDONLY);
	err = _read( inFile, E8, sizeof( E8));

	if (err == -1)
	{	perror( "prom.e8");
		exit( 1);
	}
	_close( inFile);
}

#define	bit( x, bitv)	((x & (1 << bitv)) ? 1 : 0)	// get value

enum { O1, O2, O3, O4, O5, O6, O7, O8};
enum { QA, QB, QC, QD};

uchar	E6, E6t, D6, D6t, C6, C6t, E8_adr;

void main( void)
{
	uint	count, ii;

	readProms();		// read in prom

	E6 = 0;				// clear timers
	D6 = 0;
	C6 = 0;

	for (ii = 0; ii <= 10; ii++)
	{
		// print static state

		count = E6 + (D6 << 4) + (C6 << 8);
		printf( "\n%2u = %03X, %4u, %4u", ii, count, count, (~count & 0xFFF) + 1);

		// setup static state

		E8_adr =  bit( E6, QA);
		E8_adr |= bit( E6, QD) << 1;
		E8_adr |= bit( D6, QB) << 2;
		E8_adr |= bit( D6, QC) << 3;
		E8_adr |= bit( C6, QC) << 4;

		// do a clock cycle

		E6t =  bit( E8[E8_adr], O1);
		E6t |= bit( E8[E8_adr], O2) << 1;
		E6t |= bit( E8[E8_adr], O3) << 2;
		E6t |= bit( E8[E8_adr], O4) << 3;
		D6t =  bit( E8[E8_adr], O5);
		D6t |= bit( E8[E8_adr], O6) << 1;
		D6t |= bit( E8[E8_adr], O7) << 2;
		D6t |= bit( C6, QA) << 3;
		C6t =  bit( C6, QB);
		C6t |= bit( C6, QC) << 1;
		C6t |= 0x01 << 2;
		C6t |= 0x01 << 3;

		E6 = E6t;
		D6 = D6t;
		C6 = C6t;
	}
	fputc( '\n', stdout);
}


		

		

	

	

	


